diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_svshint.c ircd-hybrid-7-bg/modules/m_svshint.c
--- ircd-hybrid-7rc5/modules/m_svshint.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-7-bg/modules/m_svshint.c	Sat May 24 23:27:10 2003
@@ -0,0 +1,132 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_svshint.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svshint.c,v 1.6 2003/05/24 00:07:45 demond Exp $
+ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "ircd.h"
+#include "hash.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void ms_svshint(struct Client*, struct Client*, int, char**);
+
+struct Message svshint_msgtab = {
+  "SVSHINT", 0, 0, 0, 0, 0, 0,
+  {m_unregistered, m_ignore, ms_svshint, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&svshint_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&svshint_msgtab);
+}
+
+const char *_version = "$Revision: 1.6 $";
+#endif
+/*
+ * ms_svshint - SVSHINT command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = hint flags
+ *      parv[2] = nick
+ */
+static void ms_svshint(struct Client* client_p, struct Client* source_p,
+                      int parc, char* parv[])
+{
+  int hint;
+  struct Client *victim;
+  
+  if (ServerInfo.gateway && get_bridge_token(client_p))
+  	return;
+
+  if (parc < 2)
+    {
+      sendto_server(client_p, source_p, NULL, CAP_SVS, NOCAPS, LL_ICLIENT, 
+      				":%s SVSHINT", parv[0]);
+
+	  if (!find_z_conf(parv[0]))
+		return;
+
+      clear_svs_client_hash_table();
+      return;
+    }
+
+  if (parc < 3)
+    return;
+
+  hint = atoi(parv[1]);
+
+  sendto_server(client_p, source_p, NULL, CAP_SVS, NOCAPS, LL_ICLIENT,
+				":%s SVSHINT %s :%s", parv[0], parv[1], parv[2]);
+
+  if (!find_z_conf(parv[0]))
+	return;
+
+  victim = find_client(parv[2]);
+
+  if (victim && !IsServer(victim))
+    {
+      if (hint == 0) {
+      	victim->svsflags &= ~FLAGS_SVS_IDENT;
+      	if (--Count.identified < 0)
+      		Count.identified = 0;
+      }
+      
+      else if (hint > 0) {
+
+      	if (hint & FLAGS_SVS_IDENT) {
+        	victim->svsflags |= FLAGS_SVS_IDENT;
+        	if (++Count.identified > Count.max_identified)
+          		Count.max_identified = Count.identified;
+      	}
+      	if (hint & FLAGS_SVS_ADMIN)
+        	victim->svsflags |= FLAGS_SVS_ADMIN;
+
+      } else {
+
+      	hint = -hint;
+      	if (hint & FLAGS_SVS_IDENT) {
+        	victim->svsflags &= ~FLAGS_SVS_IDENT;
+        	if (--Count.identified < 0)
+        		Count.identified = 0;
+      	}
+      	if (hint & FLAGS_SVS_ADMIN)
+        	victim->svsflags &= ~FLAGS_SVS_ADMIN;
+
+      }
+    }
+}
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_svshost.c ircd-hybrid-7-bg/modules/m_svshost.c
--- ircd-hybrid-7rc5/modules/m_svshost.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-7-bg/modules/m_svshost.c	Sat May 24 23:27:10 2003
@@ -0,0 +1,206 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_svshost.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svshost.c,v 1.10 2003/05/24 00:07:45 demond Exp $
+ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "ircd.h"
+#include "hash.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "vchannel.h"
+
+static void ms_svshost(struct Client*, struct Client*, int, char**);
+
+struct Message svshost_msgtab = {
+  "SVSHOST", 0, 0, 4, 0, 0, 0,
+  {m_unregistered, m_ignore, ms_svshost, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&svshost_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&svshost_msgtab);
+}
+
+const char *_version = "$Revision: 1.10 $";
+#endif
+/*
+ * ms_svshost - SVSHOST command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = remote server
+ *      parv[2] = client nick
+ *      parv[3] = vhost to spoof
+ */
+static void ms_svshost(struct Client* client_p, struct Client* source_p,
+                      int parc, char* parv[])
+{
+  char *flag;
+  struct Client *victim;
+  struct Channel *chptr, *top_chptr, *banchans[100];
+  static char comment[] = "Spoofing with vhost...";
+  static char urbanned[] = "You are banned";
+  char modebuf[MODEBUFLEN], parabuf[MODEBUFLEN];
+  int hide_or_not;
+  dlink_node *ptr;
+  int i, num = 0;
+  
+  if (ServerInfo.gateway && get_bridge_token(client_p))
+  	return;
+
+  if (hunt_server(client_p, source_p, ":%s SVSHOST %s %s :%s", 
+		  1, parc, parv) != HUNTED_ISME)
+    return;
+
+  if (!find_z_conf(parv[0]))
+    return;
+    
+  victim = find_client(parv[2]);
+  if (victim && !IsServer(victim) && MyConnect(victim))
+  {
+  	extern int introduce_client(struct Client *, struct Client *,
+  		struct User *, char *);
+  
+  	sendto_server(NULL, victim, NULL, NOCAPS, NOCAPS,
+		NOFLAGS, ":%s QUIT :%s", victim->name, comment);
+
+/*	sendto_common_channels_local(victim, ":%s!%s@%s QUIT :%s",
+		victim->name, victim->username, victim->host, comment);*/
+		
+/*	++current_serial;	not needed i suppose */
+
+	if (victim->user->channel.head)
+	for (ptr = victim->user->channel.head; ptr; ptr = ptr->next) {
+		chptr = (struct Channel *)ptr->data;
+		
+		sendto_channel_local_butone(victim, ALL_MEMBERS, 
+			chptr, ":%s!%s@%s QUIT :%s",
+			victim->name, victim->username,
+			victim->host, comment);
+	}
+	
+	strncpy(victim->host, parv[3], HOSTLEN)[HOSTLEN] = 0;
+	
+	sendto_one(victim, ":%s NOTICE %s :*** Notice -- Spoofing your host as %s",
+		me.name, victim->name, victim->host);
+	
+	if (victim->user->channel.head)
+	for (ptr = victim->user->channel.head; ptr; ptr = ptr->next) {
+		chptr = (struct Channel *)ptr->data;
+		
+#ifdef VCHANS
+		top_chptr = RootChan(chptr);
+#else
+		top_chptr = chptr;
+#endif		
+		if (is_banned(chptr, victim) & (CHFL_BAN|CHFL_DENY)) {
+			sendto_one(victim, ":%s KICK %s %s :%s",
+				me.name, top_chptr->chname, victim->name,
+				urbanned);
+			
+			/*remove_user_from_channel(chptr, victim);*/
+			banchans[num++] = chptr;
+			continue;
+		}
+		
+		if (is_chan_op(chptr, victim)) 
+			flag = "+o";
+#ifdef HALFOPS			
+		else if (is_half_op(chptr, victim)) 
+			flag = "+h";
+#endif			
+		else if (is_voiced(chptr, victim))
+			flag = "+v";
+		else flag = "";
+#ifdef REQUIRE_OANDV
+		if (find_user_link(&chptr->chanops_voiced, victim))
+			flag = "+ov";
+#endif
+		sendto_channel_local_butone(victim, ALL_MEMBERS, 
+			chptr, ":%s!%s@%s JOIN :%s",
+			victim->name, victim->username,
+			victim->host, top_chptr->chname);
+			
+#ifdef ANONOPS
+		if (chptr->mode.mode & MODE_HIDEOPS)
+			hide_or_not = ONLY_CHANOPS_HALFOPS;
+		else
+#endif
+			hide_or_not = ALL_MEMBERS;
+			
+		if (flag[0])
+		sendto_channel_local_butone(victim, hide_or_not,
+			chptr, ":%s MODE %s %s %s %s",
+			me.name, top_chptr->chname, flag,
+			victim->name, flag[2]? victim->name : "");		
+	}
+	
+	for (i=0; i < num; i++)
+		remove_user_from_channel(banchans[i], victim);
+	
+	introduce_client(NULL, victim, victim->user, victim->name);
+	
+	victim->lazyLinkClientExists = 0;	/* force introducing to LL servers below... */
+	
+	if (victim->user->channel.head)
+	for (ptr = victim->user->channel.head; ptr; ptr = ptr->next) {
+		chptr = (struct Channel *)ptr->data;
+		
+		if (is_chan_op(chptr, victim)) 
+			flag = "@";
+#ifdef HALFOPS			
+		else if (is_half_op(chptr, victim)) 
+			flag = "%";
+#endif			
+		else if (is_voiced(chptr, victim))
+			flag = "+";
+		else flag = "";
+#ifdef REQUIRE_OANDV
+		if (find_user_link(&chptr->chanops_voiced, victim))
+			flag = "@+";
+#endif
+		channel_modes(chptr, victim, modebuf, parabuf);
+		sendto_server(NULL, victim, chptr, NOCAPS, NOCAPS,
+			LL_ICLIENT|LL_ICHAN, ":%s SJOIN %lu %s %s %s :%s%s",
+			me.name, (unsigned long)chptr->channelts,
+			chptr->chname, modebuf, parabuf, 
+			flag, victim->name);
+	}
+  }
+}
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_svsmisc.c ircd-hybrid-7-bg/modules/m_svsmisc.c
--- ircd-hybrid-7rc5/modules/m_svsmisc.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-7-bg/modules/m_svsmisc.c	Sat May 24 23:27:10 2003
@@ -0,0 +1,357 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_svsmisc.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svsmisc.c,v 1.4 2003/05/24 00:07:45 demond Exp $
+ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "ircd.h"
+#include "hash.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void ms_svsjoin(struct Client*, struct Client*, int, char**);
+static void ms_svspart(struct Client*, struct Client*, int, char**);
+static void ms_svsmode(struct Client*, struct Client*, int, char**);
+
+static void svsjoin(struct Client *, char *);
+static void svspart(struct Client *, char *);
+
+struct Message svsjoin_msgtab = {
+  "SVSJOIN", 0, 0, 3, 0, 0, 0,
+  {m_unregistered, m_ignore, ms_svsjoin, m_ignore}
+};
+
+struct Message svspart_msgtab = {
+  "SVSPART", 0, 0, 2, 0, 0, 0,
+  {m_unregistered, m_ignore, ms_svspart, m_ignore}
+};
+
+struct Message svsmode_msgtab = {
+  "SVSMODE", 0, 0, 4, 0, 0, 0,
+  {m_unregistered, m_ignore, ms_svsmode, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&svsjoin_msgtab);
+  mod_add_cmd(&svspart_msgtab);
+  mod_add_cmd(&svsmode_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&svsjoin_msgtab);
+  mod_del_cmd(&svspart_msgtab);
+  mod_del_cmd(&svsmode_msgtab);
+}
+
+const char *_version = "$Revision: 1.4 $";
+#endif
+/*
+ * ms_svsjoin - SVSJOIN command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = remote server
+ *      parv[2] = nickname
+ *      parv[3] = channel to join
+ * -or-
+ *      parv[0] = sender prefix
+ *      parv[1] = channel/nick mask
+ *      parv[2] = channel to join 
+ */
+static void ms_svsjoin(struct Client* client_p, struct Client* source_p,
+                      int parc, char* parv[])
+{
+  struct Client *victim;
+  struct Channel *jchan;
+  
+  if (ServerInfo.gateway && get_bridge_token(client_p))
+  	return;
+
+  if (parc > 3) {
+
+  	if (hunt_server(client_p, source_p, ":%s SVSJOIN %s %s :%s", 
+		  1, parc, parv) != HUNTED_ISME)
+    	return;
+
+  	if (!find_z_conf(parv[0]))
+    	return;
+    	
+   	victim = find_client(parv[2]);
+  	if (victim && !IsServer(victim) && MyConnect(victim))
+  		svsjoin(victim, parv[3]);
+   	
+  } else {
+    
+    jchan = hash_find_channel(parv[2]);
+  	sendto_server(client_p, source_p, jchan, CAP_SVS, NOCAPS, LL_ICLIENT|LL_ICHAN,
+				":%s SVSJOIN %s :%s", parv[0], parv[1], parv[2]);
+
+  	if (!find_z_conf(parv[0]))
+		return;
+
+	if (parv[1][0] != '#')
+		do_local_clients(svsjoin, parv[1], parv[2]);
+		
+	else {
+	
+		if (!hash_find_channel(parv[1]))
+			return;
+		do_channel_local(svsjoin, parv[1], parv[2]);
+	}
+  }
+}
+
+/*
+ * ms_svspart - SVSPART command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = remote server
+ *      parv[2] = nickname
+ *      parv[3] = channel to part
+ * -or-
+ *      parv[0] = sender prefix
+ *      parv[1] = channel/nick mask
+ *      parv[2] = channel to part (might be missing if parv[1] is a chan) 
+ */
+static void ms_svspart(struct Client* client_p, struct Client* source_p,
+                      int parc, char* parv[])
+{
+  struct Client *victim;
+  
+  if (ServerInfo.gateway && get_bridge_token(client_p))
+  	return;
+
+  if (parc > 3) {
+
+  	if (hunt_server(client_p, source_p, ":%s SVSPART %s %s :%s", 
+		  1, parc, parv) != HUNTED_ISME)
+    	return;
+
+  	if (!find_z_conf(parv[0]))
+    	return;
+    	
+   	victim = find_client(parv[2]);
+   	if (hash_find_channel(parv[3]))
+  	if (victim && !IsServer(victim) && MyConnect(victim))
+  		svspart(victim, parv[3]);
+   	
+  } else {
+    
+  	sendto_server(client_p, source_p, NULL, CAP_SVS, NOCAPS, LL_ICLIENT,
+				":%s SVSPART %s %s", parv[0], parv[1], (parc > 2)? parv[2] : "");
+
+  	if (!find_z_conf(parv[0]))
+		return;
+		
+	if (parv[1][0] == '#')
+		if (!hash_find_channel(parv[1]))
+			return;
+	if (parc > 2)
+		if (!hash_find_channel(parv[2]))
+			return;
+
+	if (parv[1][0] != '#') {
+	
+		if (parc < 3) return;
+		do_local_clients(svspart, parv[1], parv[2]);
+		
+	} else
+		do_channel_local(svspart, parv[1], (parc > 2)? parv[2] : parv[1]);
+  }
+}
+
+/*
+ * ms_svsmode - SVSMODE command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = remote server
+ *      parv[2] = target nick
+ *      parv[3] = umode change(s)
+ */
+static void ms_svsmode(struct Client* client_p, struct Client* source_p,
+                      int parc, char* parv[])
+{
+	struct Client *victim;
+	
+	if (ServerInfo.gateway && get_bridge_token(client_p))
+		return;
+
+  	if (hunt_server(client_p, source_p, ":%s SVSMODE %s %s :%s", 
+		  1, parc, parv) != HUNTED_ISME)
+    	return;
+
+  	if (!find_z_conf(parv[0]) || !(victim = find_person(parv[2])))
+    	return;
+
+	if (MyConnect(victim)) {
+		char *argv[4];
+	
+		argv[0] = parv[2];
+		argv[1] = parv[2];
+		argv[2] = parv[3];
+		argv[3] = NULL;
+		
+		user_mode(victim, victim, 3, argv);
+	}
+}
+
+static void svsjoin(struct Client *victim, char *chan)
+{
+	int flags = 0;
+	struct Channel *chptr;
+	char modebuf[MODEBUFLEN];
+	char parabuf[MODEBUFLEN];
+
+	if (!IsChannelName(chan) || !check_channel_name(chan) 
+		|| (strlen(chan) > CHANNELLEN))
+		return;
+		
+	modebuf[0] = '+';
+	modebuf[1] = '\0';
+	parabuf[0] = '\0';
+
+	if ((chptr = hash_find_channel(chan))) {
+	
+		if (IsMember(victim, chptr)) return;
+		
+		if (chptr->users == 0)
+			flags = CHFL_CHANOP;
+		else
+			flags = 0;
+			
+	} else {
+	
+		flags = CHFL_CHANOP;
+		
+		if (!ServerInfo.hub && uplink && IsCapable(uplink, CAP_LL)) {
+		
+			sendto_one(uplink, ":%s CBURST %s %s",
+				me.name, chan, victim->name);
+			return;									/* wait for LLJOIN */
+		}
+	
+		if (!(chptr = get_or_create_channel(victim, chan, NULL)))
+			return;
+	}
+	
+	add_user_to_channel(chptr, victim, flags);
+	
+	if (flags & CHFL_CHANOP) {
+	
+		chptr->channelts = CurrentTime;
+		chptr->mode.mode |= MODE_TOPICLIMIT;
+		chptr->mode.mode |= MODE_NOPRIVMSGS;
+		modebuf[0] = '+';
+		modebuf[1] = 'n';
+		modebuf[2] = 't';
+		modebuf[3] = '\0';
+	
+		sendto_server(NULL, victim, chptr, NOCAPS, NOCAPS, LL_ICLIENT,
+			":%s SJOIN %lu %s %s %s:@%s",
+			me.name, (unsigned long) chptr->channelts,
+			chptr->chname, modebuf, parabuf, victim->name);
+			
+	  	sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+			       victim->name, victim->username,
+			       victim->host, chptr->chname);
+      
+		sendto_channel_local(ONLY_CHANOPS_HALFOPS, chptr, ":%s MODE %s %s %s",
+			       me.name, chptr->chname,
+			       modebuf, parabuf);
+	} else {
+
+		sendto_server(NULL, victim, chptr, NOCAPS, NOCAPS, LL_ICLIENT,
+			":%s SJOIN %lu %s %s %s:%s",
+			me.name, (unsigned long) chptr->channelts,
+			chptr->chname, modebuf, parabuf, victim->name);
+
+		sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+			       victim->name, victim->username,
+			       victim->host, chptr->chname);
+	}
+	
+	del_invite(chptr, victim);
+
+	if (chptr->topic != NULL) {
+	  	char foo[TOPICLEN]; 
+	  
+	  	strlcpy(foo, chptr->topic, TOPICLEN);
+	  	sendto_one(victim, form_str(victim,RPL_TOPIC),
+		     me.name, victim->name, chptr->chname, 
+		     ConfigFileEntry.totaltrans?
+		     translate(victim, foo) : chptr->topic);
+
+		if (!(chptr->mode.mode & MODE_HIDEOPS) ||
+			(flags & CHFL_CHANOP) || (flags & CHFL_HALFOP))
+            {
+              sendto_one(victim, form_str(victim,RPL_TOPICWHOTIME),
+                         me.name, victim->name, chptr->chname,
+                         chptr->topic_info, chptr->topic_time);
+            }
+          else /* Hide from nonops */
+            {
+              sendto_one(victim, form_str(victim,RPL_TOPICWHOTIME),
+                         me.name, victim->name, chptr->chname,
+                         me.name, chptr->topic_time);
+            }
+	}
+
+	channel_member_names(victim, chptr, chptr->chname, 1);
+	victim->localClient->last_join_time = CurrentTime;
+}
+
+static void svspart(struct Client *victim, char *chan)
+{
+	struct Channel *chptr;
+	static char reason[] = "SVSPART";
+
+	if (!(chptr = hash_find_channel(chan)) || !IsMember(victim, chptr))
+		return;
+
+	sendto_server(NULL, NULL, chptr, CAP_UID, NOCAPS, NOFLAGS,
+                    ":%s PART %s :%s", ID(victim), chptr->chname,
+                    reason);
+	sendto_server(NULL, NULL, chptr, NOCAPS, CAP_UID, NOFLAGS,
+                    ":%s PART %s :%s", victim->name, chptr->chname,
+                    reason);
+                    
+	sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s PART %s :%s",
+                           victim->name,
+                           victim->username,
+                           victim->host,
+                           chptr->chname,
+                           reason);
+                           
+	remove_user_from_channel(chptr, victim);
+	victim->localClient->last_leave_time = CurrentTime;
+}
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_svsnick.c ircd-hybrid-7-bg/modules/m_svsnick.c
--- ircd-hybrid-7rc5/modules/m_svsnick.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-7-bg/modules/m_svsnick.c	Sat May 24 23:27:10 2003
@@ -0,0 +1,94 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_svsnick.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svsnick.c,v 1.3 2003/05/24 00:07:45 demond Exp $
+ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "ircd.h"
+#include "hash.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void ms_svsnick(struct Client*, struct Client*, int, char**);
+
+struct Message svsnick_msgtab = {
+  "SVSNICK", 0, 0, 4, 0, 0, 0,
+  {m_unregistered, m_ignore, ms_svsnick, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&svsnick_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&svsnick_msgtab);
+}
+
+const char *_version = "$Revision: 1.3 $";
+#endif
+/*
+ * ms_svsnick - SVSNICK command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = remote server
+ *      parv[2] = old nick
+ *      parv[3] = new nick
+ */
+static void ms_svsnick(struct Client* client_p, struct Client* source_p,
+                      int parc, char* parv[])
+{
+  struct Client *victim;
+  
+  if (ServerInfo.gateway && get_bridge_token(client_p))
+  	return;
+
+  if (hunt_server(client_p, source_p, ":%s SVSNICK %s %s :%s", 
+		  1, parc, parv) != HUNTED_ISME)
+    return;
+
+  if (!find_z_conf(parv[0]))
+    return;
+    
+  victim = find_client(parv[2]);
+  if (victim && !IsServer(victim) && MyConnect(victim))
+  {
+    if (find_client(parv[3]))
+	{
+	  exit_client(victim, victim, &me, "SVSNICK collision");
+	  return;
+	}
+
+    change_local_nick(victim, victim, parv[3]);
+  }
+}
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_testline.c ircd-hybrid-7-bg/modules/m_testline.c
--- ircd-hybrid-7rc5/modules/m_testline.c	Wed Sep 11 18:01:05 2002
+++ ircd-hybrid-7-bg/modules/m_testline.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_testline.c,v 1.26 2002/09/11 22:01:05 db Exp $
+ *  $Id: m_testline.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "stdinc.h"
@@ -59,7 +59,7 @@
   mod_del_cmd(&testline_msgtab);
 }
  
-const char *_version = "$Revision: 1.26 $";
+const char *_version = "$Revision: 1.1.1.1 $";
 #endif
 /*
  * mo_testline
@@ -132,9 +132,9 @@
 #else
           AF_INET
 #endif
-         );
+         , NULL);
       else
-       aconf = find_address_conf(given_host, given_name, NULL, 0);
+       aconf = find_address_conf(given_host, given_name, NULL, 0, NULL);
                  
       if(aconf)
         {
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_time.c ircd-hybrid-7-bg/modules/m_time.c
--- ircd-hybrid-7rc5/modules/m_time.c	Sat Jul 20 11:51:47 2002
+++ ircd-hybrid-7-bg/modules/m_time.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_time.c,v 1.26 2002/07/20 15:51:47 leeh Exp $
+ *  $Id: m_time.c,v 1.3 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -57,7 +57,7 @@
   mod_del_cmd(&time_msgtab);
 }
 
-const char *_version = "$Revision: 1.26 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_time
@@ -78,7 +78,7 @@
         return;
     }
 
-  sendto_one(source_p, form_str(RPL_TIME), me.name,
+  sendto_one(source_p, form_str(source_p,RPL_TIME), me.name,
              parv[0], me.name, date(0));
 }
 
@@ -90,7 +90,9 @@
 static void mo_time(struct Client *client_p, struct Client *source_p,
                    int parc, char *parv[])
 {
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+
   if (hunt_server(client_p,source_p,":%s TIME :%s",1,parc,parv) == HUNTED_ISME)
-    sendto_one(source_p, form_str(RPL_TIME), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_TIME), me.name,
                parv[0], me.name, date(0));
 }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_topic.c ircd-hybrid-7-bg/modules/m_topic.c
--- ircd-hybrid-7rc5/modules/m_topic.c	Mon Jun 10 21:39:38 2002
+++ ircd-hybrid-7-bg/modules/m_topic.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_topic.c,v 1.54 2002/06/11 01:39:38 androsyn Exp $
+ *  $Id: m_topic.c,v 1.4 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -40,6 +40,7 @@
 #include "parse.h"
 #include "modules.h"
 #include "packet.h"
+#include "s_misc.h"
 
 static void m_topic(struct Client*, struct Client*, int, char**);
 static void ms_topic(struct Client*, struct Client*, int, char**);
@@ -62,7 +63,7 @@
   mod_del_cmd(&topic_msgtab);
 }
 
-const char *_version = "$Revision: 1.54 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 /*
  * m_topic
@@ -105,7 +106,7 @@
         }
         else
         {
-          sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+          sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
                      me.name, parv[0], parv[1]);
           return;
         }
@@ -129,7 +130,7 @@
 	{
 	  if (!IsMember(source_p, chptr))
 	    {
-	      sendto_one(source_p, form_str(ERR_NOTONCHANNEL), me.name, parv[0],
+	      sendto_one(source_p, form_str(source_p,ERR_NOTONCHANNEL), me.name, parv[0],
 			 parv[1]);
 	      return;
 	    }
@@ -137,9 +138,14 @@
 	      is_any_op(chptr,source_p))
 	    {
 	      char topic_info[USERHOST_REPLYLEN]; 
-              ircsprintf(topic_info, "%s!%s@%s",
+
+	      if (NoColorChannel(chptr)) 
+			/*strip_color(parv[2]);*/
+			parv[2] = strip_color(parv[2], 0);
+
+          ircsprintf(topic_info, "%s!%s@%s",
 			 source_p->name, source_p->username, source_p->host);
-              set_channel_topic(chptr, parv[2], topic_info, CurrentTime);
+          set_channel_topic(chptr, parv[2], topic_info, CurrentTime);
 	      
 	      sendto_server(client_p, NULL, chptr, NOCAPS, NOCAPS, NOFLAGS,
                             ":%s TOPIC %s :%s",
@@ -172,30 +178,33 @@
 		}
 	    }
 	  else
-            sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED),
+            sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED),
                        me.name, parv[0], parv[1]);
 	}
       else  /* only asking  for topic  */
 	{
 	  if (!IsMember(source_p, chptr) && SecretChannel(chptr))
 	    {
-	      sendto_one(source_p, form_str(ERR_NOTONCHANNEL), me.name, parv[0],
+	      sendto_one(source_p, form_str(source_p,ERR_NOTONCHANNEL), me.name, parv[0],
 			 parv[1]);
 	      return;
 	    }
           if (chptr->topic == NULL)
-	    sendto_one(source_p, form_str(RPL_NOTOPIC),
+	    sendto_one(source_p, form_str(source_p,RPL_NOTOPIC),
 		       me.name, parv[0], parv[1]);
           else
 	    {
-              sendto_one(source_p, form_str(RPL_TOPIC),
+	          char foo[TOPICLEN]; strlcpy(foo, chptr->topic, TOPICLEN);
+              sendto_one(source_p, form_str(source_p,RPL_TOPIC),
                          me.name, parv[0],
-                         root_chan->chname, chptr->topic);
+                         root_chan->chname, 
+                         ConfigFileEntry.totaltrans?
+                         translate(source_p, foo) : chptr->topic);
 
                 if(!(chptr->mode.mode & MODE_HIDEOPS) ||
                   is_any_op(chptr,source_p))
                 {
-                  sendto_one(source_p, form_str(RPL_TOPICWHOTIME),
+                  sendto_one(source_p, form_str(source_p,RPL_TOPICWHOTIME),
                              me.name, parv[0], root_chan->chname,
                              chptr->topic_info,
                              chptr->topic_time);
@@ -207,14 +216,14 @@
 	        else if(ConfigServerHide.hide_servers && !MyClient(source_p)
 	                && IsCapable(client_p, CAP_LL) && ServerInfo.hub)
   	        {
-	          sendto_one(source_p, form_str(RPL_TOPICWHOTIME),
+	          sendto_one(source_p, form_str(source_p,RPL_TOPICWHOTIME),
 	  	             me.name, parv[0], root_chan->chname,
 	  		     client_p->name, chptr->topic_time);
                 }
   	        /* just normal topic hiding.. */
 	        else
 	 	{
-                  sendto_one(source_p, form_str(RPL_TOPICWHOTIME),
+                  sendto_one(source_p, form_str(source_p,RPL_TOPICWHOTIME),
                              me.name, parv[0], root_chan->chname,
                              me.name,
                              chptr->topic_time);
@@ -224,7 +233,7 @@
     }
   else
     {
-      sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
                  me.name, parv[0], parv[1]);
     }
 }
@@ -246,6 +255,9 @@
 {
   struct Channel *chptr = NULL;
   
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  cluster_prefix(client_p, parc, parv, 1, 1, 0);
+  
   if (!IsServer(source_p))
   {
     m_topic(client_p, source_p, parc, parv);
@@ -258,25 +270,33 @@
   if (parv[1] && IsChannelName(parv[1]))
     {
       if ((chptr = hash_find_channel(parv[1])) == NULL)
-	return;
+		return;
       
+      /*if ((time_t)atoi(parv[3]) > chptr->topic_time)
+        return;*/
+      if (chptr->topic && *(chptr->topic))
+        return;
+
+      if (NoColorChannel(chptr)) 
+		/*strip_color(parv[4]);*/
+		parv[4] = strip_color(parv[4], 0);
+
       set_channel_topic(chptr, parv[4], parv[2], atoi(parv[3]));
 
       if(ConfigServerHide.hide_servers)
-	{
-	  sendto_channel_local(ALL_MEMBERS,
+		{
+	  		sendto_channel_local(ALL_MEMBERS,
 			       chptr, ":%s TOPIC %s :%s",
 			       me.name,
 			       parv[1],
 			       chptr->topic == NULL ? "" : chptr->topic);
-
-	}
+		}
       else
-	{
-	  sendto_channel_local(ALL_MEMBERS,
+		{
+	  		sendto_channel_local(ALL_MEMBERS,
 			       chptr, ":%s TOPIC %s :%s",
 			       source_p->name,
 			       parv[1], chptr->topic == NULL ? "" : chptr->topic);
-	}
+		}
     }
 }
